function Player::useForce(%this)
{
   %this.force = 1;
   %this.forceLoop();
}
function Player::ForceLoop(%this)
{
   cancel($ForceLoop[%this]);
   if(%this.JediSlot[2] && %this.getEnergyLevel() > 1)
   {
      if(!%this.client.hostMode)
      %this.setEnergyLevel(%this.getEnergyLevel()-2);
      if(!%this.jediTarget || !isObject(%this.jediTarget))
      {
         if(!%this.client.hostMode)
         %target = %this.ForceTarget(30);
         else
         %target = %this.ForceTarget(1000);
      }
      else
         %target = %this.jediTarget;
      %this.jediTarget = %target;
      if(!isObject(%target))
      {
         %this.force = 0;
         return;   
      }
      if(!%this.client.hostMode)
      if(%this.client.noforce || %this.jeditarget.client.noforce)
      {
         %this.force = 0;
         return;   
      }
      if(!%this.client.hostMode)
      if(%this == %target.jeditarget || %target.jeditarget == %this )
      {
         if(!%this.getClassName() $= "Vehicle")
         {
            %this.force = 0;
            return;   
         }
      }
      %this.Force_Move(%target);
      if(%this.jediSlot[0])
         %this.Force_Away(%target);
      else if(%this.jediSlot[4])
         %this.Force_Near(%target);
   }
   else
   {
      if(isObject(%this.JediTarget) || %this.jediTarget)
      {
         %this.targetPos = "";
         %this.jediTarget = 0;
         %this.jediTargetDist = 0;
      }
   }
   if(isObject(%this))
   $ForceLoop[%this] = schedule(50,0,eval,%this@".ForceLoop();");
}
function Player::Force_SetPos(%this,%target)
{  %pos = vectorAdd(%this.getPosition(),vectorScale(%this.getEyeVector(), %this.jediTargetDist));
   %x = getWord(%pos,0);
   %y = getWord(%pos,1);
   %z = getWord(%pos,2)+getWord(%target.scale,2)*2;
   %this.targetPos = %x SPC %Y SPC %z;
   %target.velTo(%x SPC %y SPC %z);
   
}
function servercmdnoforce(%cl)
{
   %cl.noforce = !%cl.noforce;
   if(%cl.noforce)
      announce(%cl.name@" does not want to be forced...");
   else
      announce(%cl.name@" is okay with being forced...");
}
function servercmdforcehost(%cl)
{
   if(!%cl.isSuperAdmin)
      return;
   %cl.hostMode = !%cl.hostMode;
   if(%cl.hostMode)
      announce(%cl.name@" is using force HostMode...");
   else
      announce(%cl.name@" is no longer using force HostMode...");
}
function Player::Force_Move(%this,%target)
{
   if(%this.targetPos $= "")
      %this.targetPos = %target.getPosition();
   if(!%this.jediTargetDist)
      %this.jediTargetDist = vectorDist(%this.getPosition(), %this.targetPos);
   %this.Force_SetPos(%target);
}
function Player::Force_Away(%this,%target)
{
   if(%this.jediTargetDist <= 30 || %this.client.hostMode)
      %this.jediTargetDist += 1;
   else
      %this.jediTargetDist = 30;
   %this.Force_SetPos(%target);
}
function Player::Force_Near(%this,%target)
{
   if(%this.jediTargetDist >= 3)
      %this.jediTargetDist -= 1;
   else
      %this.jediTargetDist = 3;
   %this.Force_SetPos(%target);
}
function Player::velTo(%this,%pos)
{
   %this.addVelocity(vectorScale(vectorSub(%this.getPosition(),%pos), -vectorDist(%this.getPosition(),%pos)/2));
}
function Vehicle::VelTo(%this,%pos)
{
   %this.setVelocity(vectorScale(vectorSub(%this.getPosition(),%pos), -vectorDist(%this.getPosition(),%pos)/2));
}
function Player::ForceTarget(%this,%dist)
{
    %start = %this.getEyePoint();
    %vec   = %this.getEyeVector();
    %end   = vectorAdd(%start,vectorScale(%vec,%dist));
    %ray = containerRaycast(%start,%end,($TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType),%this);
    %col = firstWord(%ray);
    if(!isObject(%col))
      return -1;
    return %col;
}


datablock PlayerData(PlayerJediArmor : PlayerStandardArmor)
{
	firstPersonOnly = 0;
	canJet = 0;
	uiName = "Jedi Player";
	showEnergyBar = 1;
   rechargeRate = 0.5;	
	jumpForce = 0;	
	
	maxForwardSpeed = 6;
	maxBackwardSpeed = 6;
	maxSideSpeed = 6;
	maxForwardCrouchSpeed = 3;
	maxBackwardCrouchSpeed = 3;
	maxSideCrouchSpeed = 3;
	maxUnderwaterForwardSpeed = 4;
	maxUnderwaterBackwardSpeed = 4;
	maxUnderwaterSideSpeed = 4;
	maxTools = 6;
	maxWeapons = 6;
};
package JediPlayer
{
   function Armor::onTrigger(%data,%player,%slot,%io)
	{
      if(%player.getDatablock().getName() $= "PlayerJediArmor")
      {
         %player.JediSlot[%slot] = %io;
         if(!%player.force)
            %player.useForce();
      }
		Parent::onTrigger(%data,%player,%slot,%io);
	}
};
activatepackage(JediPlayer);